/*

AutoMarks 0.2

Autocomplete in the Location bar with URLs from your bookmarks.

By Amanuel Tewolde - http://www.ticklespace.com

*/

// Big thanks to: 
// 		Christian Biesinger
// 		Neil Rashbrook

function AutoMarks() {
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                    .getService(Components.interfaces.nsIPromptService);


	if (promptService.confirm(window,"AutoMarks","Copy Bookmarks to AutoComplete now?")){
		var ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		var newEntry = Components.classes['@mozilla.org/browser/global-history;2'].getService(Components.interfaces.nsIGlobalHistory2);
		var root=RDF.GetResource("NC:BookmarksRoot");
		var urlArc = RDF.GetResource(gNC_NS+"URL");    //URL property
		var urlArcName = RDF.GetResource(gNC_NS+"Name");    //URL Name property
	
		var bookmarkfolder=[root];
		
		BMDS.beginUpdateBatch();
		while(bookmarkfolder.length>0)
		{
	
			RDFC.Init(BMDS,bookmarkfolder.shift());
	
			var elements=RDFC.GetElements();
	
			var bookmarks=[];
	
			while(elements.hasMoreElements())
			{
				var element=elements.getNext();
				element.QueryInterface(Components.interfaces.nsIRDFResource);
	
				var type=BookmarksUtils.resolveType(element);
	
				if(type=="Folder" ||type=="PersonalToolbarFolder"){
					
					bookmarkfolder.push(element);
					//not a url - found folder add it to folders being processed.;
				
				} else if(type=="BookmarkSeparator"){
	
					//not a url;
	
				} else { 
					bookmarks.push(element);
	
				}
			}
	
			for(var i in bookmarks) {
				var res = RDF.GetResource(bookmarks[i].Value);
				var target = BMDS.GetTarget(res, urlArc, true);
				var targetName = BMDS.GetTarget(res, urlArcName, true);
				if(target) {
					var newurl = target.QueryInterface(kRDFLITIID).Value;
					var urlName = targetName.QueryInterface(kRDFLITIID).Value;
			
					var newURI = ioService.newURI(newurl, null, null);
					newEntry.addURI(newURI, false, true, null);
					if(urlName)
					newEntry.setPageTitle(newURI, urlName);
				}
	
			}
	
		}
	
		BMDS.endUpdateBatch();
		BMDS.transactionManager.clear();
		alert("Bookmarks Transfer Successful.");
	}
}
